CLASS 		Body

GLOBAL		#define CONSTRAINT(var,idx) if (var<constraints[idx][0]) \\
											var=constraints[idx][0]; \\
                                        else if (var>constraints[idx][1]) \\
											var=constraints[idx][1];

CODE_SET	// force the redisplay \
			Redisplay();			

#-------------------------------------------------------------------------------------------------
# name			type		var associated			set code (%!=entry idx, %$ = var name)

### body  -- WARNING -- in same order as track enum
pelvis:X		double		joints[pelvisX]			if (constraint) { CONSTRAINT(%$,%!) }
pelvis:Y		double		joints[pelvisY]			if (constraint) { CONSTRAINT(%$,%!) }
pelvis:Z		double		joints[pelvisZ]			if (constraint) { CONSTRAINT(%$,%!) }

torso:X			double		joints[torsoX]			if (constraint) { CONSTRAINT(%$,%!) }
torso:Y			double		joints[torsoY]			if (constraint) { CONSTRAINT(%$,%!) }
torso:Z			double		joints[torsoZ]			if (constraint) { CONSTRAINT(%$,%!) }

head:X			double		joints[headX]			if (constraint) { CONSTRAINT(%$,%!) }
head:Y			double		joints[headY]			if (constraint) { CONSTRAINT(%$,%!) }
head:Z			double		joints[headZ]			if (constraint) { CONSTRAINT(%$,%!) }

### left part
left:shoulder:X	double		joints[lShoulderX]		if (constraint) { CONSTRAINT(%$,%!) }
left:shoulder:Y	double		joints[lShoulderY]		if (constraint) { CONSTRAINT(%$,%!) }
left:shoulder:Z	double		joints[lShoulderZ]		if (constraint) { CONSTRAINT(%$,%!) }
left:shoulder:TY	double	joints[lShoulderTY]		if (constraint) { CONSTRAINT(%$,%!) }

left:elbow:X	double		joints[lElbowX]			if (constraint) { CONSTRAINT(%$,%!) }
left:elbow:Y	double		joints[lElbowY]			if (constraint) { CONSTRAINT(%$,%!) }

left:wrist:X	double		joints[lWristX]			if (constraint) { CONSTRAINT(%$,%!) }
left:wrist:Y	double		joints[lWristY]			if (constraint) { CONSTRAINT(%$,%!) }
left:wrist:Z	double		joints[lWristZ]			if (constraint) { CONSTRAINT(%$,%!) }

left:hip:X		double		joints[lHipX]			if (constraint) { CONSTRAINT(%$,%!) }
left:hip:Y		double		joints[lHipY]			if (constraint) { CONSTRAINT(%$,%!) }
left:hip:Z		double		joints[lHipZ]			if (constraint) { CONSTRAINT(%$,%!) }

left:knee:X		double		joints[lKneeX]			if (constraint) { CONSTRAINT(%$,%!) }

left:ankle:X	double		joints[lAnkleX]			if (constraint) { CONSTRAINT(%$,%!) }
left:ankle:Y	double		joints[lAnkleY]			if (constraint) { CONSTRAINT(%$,%!) }
left:ankle:Z	double		joints[lAnkleZ]			if (constraint) { CONSTRAINT(%$,%!) }

left:foot:X		double		joints[lFootX]			if (constraint) { CONSTRAINT(%$,%!) }

### right part
right:shoulder:X	double	joints[rShoulderX]		if (constraint) { CONSTRAINT(%$,%!) }
right:shoulder:Y	double	joints[rShoulderY]		if (constraint) { CONSTRAINT(%$,%!) }
right:shoulder:Z	double	joints[rShoulderZ]		if (constraint) { CONSTRAINT(%$,%!) }
right:shoulder:TY	double	joints[rShoulderTY]		if (constraint) { CONSTRAINT(%$,%!) }

right:elbow:X	double		joints[rElbowX]			if (constraint) { CONSTRAINT(%$,%!) }
right:elbow:Y	double		joints[rElbowY]			if (constraint) { CONSTRAINT(%$,%!) }

right:wrist:X	double		joints[rWristX]			if (constraint) { CONSTRAINT(%$,%!) }
right:wrist:Y	double		joints[rWristY]			if (constraint) { CONSTRAINT(%$,%!) }
right:wrist:Z	double		joints[rWristZ]			if (constraint) { CONSTRAINT(%$,%!) }

right:hip:X		double		joints[rHipX]			if (constraint) { CONSTRAINT(%$,%!) }
right:hip:Y		double		joints[rHipY]			if (constraint) { CONSTRAINT(%$,%!) }
right:hip:Z		double		joints[rHipZ]			if (constraint) { CONSTRAINT(%$,%!) }

right:knee:X	double		joints[rKneeX]			if (constraint) { CONSTRAINT(%$,%!) }

right:ankle:X	double		joints[rAnkleX]			if (constraint) { CONSTRAINT(%$,%!) }
right:ankle:Y	double		joints[rAnkleY]			if (constraint) { CONSTRAINT(%$,%!) }
right:ankle:Z	double		joints[rAnkleZ]			if (constraint) { CONSTRAINT(%$,%!) }

right:foot:X	double		joints[rFootX]			if (constraint) { CONSTRAINT(%$,%!) }

# cog
cog:X			double		joints[cogX]
cog:Y			double		joints[cogY]
cog:Z			double		joints[cogZ]
cog:rX			double		joints[cogRX]
cog:rY			double		joints[cogRY]
cog:rZ			double		joints[cogRZ]

### interface
name			string		name
sex				user		-
ghost			user		-


#-------------------------------------------------------------------------------------------------
#	 name					vars in list

LIST cog					cog:X cog:Y cog:Z cog:rX cog:rY cog:rZ 

LIST torso					torso:X torso:Y torso:Z 
LIST pelvis					pelvis:X pelvis:Y pelvis:Z
LIST body					torso pelvis

LIST head					head:X head:Y head:Z


LIST left:shoulder			left:shoulder:X left:shoulder:Y left:shoulder:Z left:shoulder:TY
LIST left:elbow				left:elbow:X left:elbow:Y
LIST left:wrist				left:wrist:X left:wrist:Y left:wrist:Z
LIST left:arm				left:shoulder left:elbow left:wrist

LIST left:hip				left:hip:X left:hip:Y left:hip:Z
LIST left:ankle				left:ankle:X left:ankle:Y left:ankle:Z
LIST left:foot				left:ankle:X left:ankle:Y left:ankle:Z left:foot:X
LIST left:leg				left:hip left:knee:X left:ankle left:foot:X


LIST right:shoulder			right:shoulder:X right:shoulder:Y right:shoulder:Z right:shoulder:TY
LIST right:elbow			right:elbow:X right:elbow:Y
LIST right:wrist			right:wrist:X right:wrist:Y right:wrist:Z
LIST right:arm				right:shoulder right:elbow right:wrist

LIST right:hip				right:hip:X right:hip:Y right:hip:Z
LIST right:ankle			right:ankle:X right:ankle:Y right:ankle:Z
LIST right:foot				right:ankle:X right:ankle:Y right:ankle:Z right:foot:X
LIST right:leg				right:hip right:knee:X right:ankle right:foot:X

LIST pose					head body left:arm right:arm left:leg right:leg

LIST all					cog pose


#------------------------------------------------------------------------------------------------

USER_GET sex		{__res = Tcl_NewStringObj((char *) (sex == MAN ? "man" : "woman"), -1); }

USER_SET sex		{__str = Tcl_GetStringFromObj(objv[3], NULL); \
					if (strcmp(__str,"man")==0) {\
						sex = MAN; \
					} else if (strcmp(__str,"woman")==0) {\
						sex = WOMAN; \
					} else { \
						Tcl_AppendResult(interp,"bad sex, should be man or woman", \
										 (char *) NULL); \
						return TCL_ERROR; \
					} \
					torso.SetDrawId(sex == MAN ? OBJ_TORSO_MAN : OBJ_TORSO_WOMAN); }

#------------------------------------------------------------------------------------------------

USER_GET ghost		{__res = Tcl_NewStringObj((char *) (ghost == BODY ? "body" : \
											  			ghost == GHOST ? "ghost" : "foot"), -1); }

USER_SET ghost		{__str = Tcl_GetStringFromObj(objv[3], NULL); \
					if (strcmp(__str,"body")==0) {\
						ghost = BODY; \
					} else if (strcmp(__str,"ghost")==0) {\
						ghost = GHOST; \
					} else if (strcmp(__str,"foot")==0) {\
						ghost = FOOT; \
					} else { \
						Tcl_AppendResult(interp,"bad value, should be body, ghost or foot", \
										 (char *) NULL); \
						return TCL_ERROR; \
					} }

