#include "togl.h"
#include "global.h"
#include <ctype.h>
#include <string.h>


//================================================================================================

int Check_ObjCmd(ClientData clientData, Tcl_Interp *interp, int objc, Tcl_Obj *CONST objv[])
{
static char *cmdPtr[] = {"figures", "usefigure", "usecategory", "useclass", (char *) 0};
enum {figs, ufigure, ucategory, uclass} cmd;
char *filename, *element = 0, tmp[256], data[256], *ptr;
int slash1, slash2;
FILE *in;
Tcl_Obj *res = 0;


	if (objc < 3) {
		Tcl_WrongNumArgs(interp, 1, objv, "command filename element");
		return TCL_ERROR;
	}

	// cmd
	if (Tcl_GetIndexFromObj(interp, objv[1], cmdPtr, "command", 0, (int *) &cmd) != TCL_OK) {
		return TCL_ERROR;
	}
	// parameters
	filename = Tcl_GetStringFromObj(objv[2], NULL);
#ifdef WIN32
	strcpy(tmp, filename);
	for(ptr = tmp; *ptr != '\0'; ptr++) {
		if (*ptr == '/') {
			*ptr = '\\';
		}
	}
	filename = tmp;
#endif
	if (cmd == figs) {
		res = Tcl_NewListObj(0, NULL);
	} else {
		if (objc < 4) {
			Tcl_WrongNumArgs(interp, 3, objv, "element");
			return TCL_ERROR;
		}
		element = Tcl_GetStringFromObj(objv[3], NULL);
	}

	// open the file and search the element
	if ((in = fopen(filename, "r")) == 0) {
        Tcl_AppendResult(interp, "can't open file\n", TCL_STATIC);
		return TCL_ERROR;
	}
	while (!feof(in)) {
		fgets(tmp, 255, in);
		if (strncmp(tmp, "routine(", 8) == 0) {
			ptr = tmp+8;
			while (*ptr && (isalnum(*ptr) || *ptr=='_' || *ptr=='-' || *ptr=='/')) {
				ptr++;
			}
			strncpy(data, tmp+8, ptr-(tmp+8));
			data[ptr-(tmp+8)] = '\0';
//fprintf(stderr, "FOUND = %s in %s\n", data, filename);

			// if cmd is category, extract it
			if (cmd == ucategory) {
				slash1 = 0;
				while (data[slash1] && data[slash1] != '/') slash1++;

				slash2 = strlen(data);
				while (slash2>0 && data[slash2] != '/') slash2--;

				strncpy(tmp, data, strlen(data));
				strncpy(data, tmp, slash2);
				data[slash2] = '\0';

			} else if (cmd == uclass) {
				// extract the category
				slash1 = 0;
				while (data[slash1] && data[slash1] != '/') slash1++;

				data[slash1] = '\0';
			}
//fprintf(stderr, "AFTER TRANS = %s\n", data);

			if (cmd == figs) {
				// if list of figures, append to list
				Tcl_ListObjAppendElement(interp, res, Tcl_NewStringObj(data, -1));

			} else if (strcmp(data, element) == 0) {
				// found, return TRUE
				fclose(in);
				Tcl_SetObjResult(interp, Tcl_NewBooleanObj(TRUE));
				return TCL_OK;
			}

		}
	}

	// not found, return FALSE
	fclose(in);
	if (cmd == figs) {
		Tcl_SetObjResult(interp, res);
	} else {
		Tcl_SetObjResult(interp, Tcl_NewBooleanObj(FALSE));
	}
	return TCL_OK;
}
