proc routine::figure:dialog {w routine apply} {
variable $w
upvar 0 $w data
global __editmapstatus__


	# create the window
	set top [toplevel .editmap]
    wm title $top "Figure"
	wm geometry $top +[winfo pointerx .]+[winfo pointery .]
	wm resizable $top false false
    bind $top <Alt-w> "set __editmapstatus__ 0"
    bind $top <Alt-o> "set __editmapstatus__ 1"
    bind $top <Alt-c> "set __editmapstatus__ 0"
	bind $top <Return> "set __editmapstatus__ 1"
    bind $top <Escape> "set __editmapstatus__ 0"

	# extract names
	set data(t:figure) $routine
	set nb [$routine get dancers]
	for {set i 0} {$i < $nb} {incr i} {
		lappend names [$routine get dancername $i]
	}

	# notebook for mapping/conflic
	set data(w:t:notebook) [tixNoteBook $top.n]
	  $top.n subwidget nbframe configure -bd 1
	$data(w:t:notebook) add map -label Mapping -underline 0
	  figure:mapping $w $names $apply
	$data(w:t:notebook) add conflict -label Reject -underline 0 \
					-createcmd "routine::figure:conflicts $w [list $names] $apply" \
					-raisecmd "routine::figure:conflicts:setup $w [list $names]"
	  set data(t:dancer) -1
	  foreach n $names {
		  lappend data(t:conflicts) {}
		  lappend data(t:rejects) {}
	  }
	  set data(t:setup) 0

	# the buttons
	set f [frame $top.buttons -relief raise -bd 1]
	  button $f.ok -default active -text "OK" -width 5 -underline 0 \
			-command "set __editmapstatus__ 1" 
	  button $f.cancel -text "Cancel" -command "set __editmapstatus__ 0" -width 5 -underline 0
	  grid $f.ok $f.cancel -padx 5 -pady 3

	# the layout
	pack $top.n -expand true -fill both -pady 5 -padx 5
	pack $top.buttons -expand true -fill x


	# give the focus
	while {1} {
		grab set $top
		tkwait variable __editmapstatus__
		grab release $top

		if {$__editmapstatus__} {
			set data(t:map) {}
			for {set i 0} {$i<$data(t:nbmap)} {incr i} {
				lappend data(t:map) $data(t:d$i)
			}
			if {!$data(t:setup)} {
				set data(t:conflicts) [$data(v:routine) checkinsertion $data(t:figure) \
												$data(t:apply) $data(t:dropTime) $data(t:map)]
				set data(t:rejects) $data(t:conflicts)
			}

			set isconflicts 0
			foreach l $data(t:rejects) {
				if {[llength $l]>0} {
					set isconflicts 1
				}
			}

			if {[figure:conflicts:check $w]} {
				set doit "yes"
				if {$isconflicts} {
					set doit [tk_messageBox -icon "question" -type yesno \
							-default yes -title "Error" \
							-message "There are some conflicts for the insertion.\nContinue ?"]
				}
				if {$doit == "yes"} {
					destroy $top
					return "OK"
				}
			} else {
				$data(w:t:notebook) raise conflict
				tk_messageBox -icon "error" -title "Error" -message $data(t:error) -type ok
			}
		} else {
			destroy $top
			return "Canceled"
		}
	}
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:mapping {w names apply} {
variable $w
upvar 0 $w data


	set top [$data(w:t:notebook) subwidget map]

	# choose the mappings between routine & figure
	label $top.map_l -text "Mapping"
	set data(w:map) [frame $top.map -relief groove -bd 2]
	set f $data(w:map)
	  # build list of dancers for routine
	  set dancers {}
	  for {set i 0} {$i<[$data(v:routine) get dancers]} {incr i} {
		  lappend dancers [$data(v:routine) get dancername $i]
	  }
	  # construct mapping widget
	  set i 0
	  foreach n $names {
		  label $f.d$i -text "$n" -font routine:map
		  label $f.t$i -text "to" -font routine:map
		  menubutton $f.m$i -indicatoron 1 -menu $f.m$i.m -font routine:map \
				  -relief raised -anchor w -direction below -bd 1
	  		menu $f.m$i.m -activeborderwidth 1 -bd 1 -font menubutton -tearoff 0
			set j 0
		    foreach d $dancers {
				$f.m$i.m add command -label $d \
						-command "routine::figure:mapping:selectDancer $w $i $j"
				incr j
			}
			$f.m$i.m add separator
			$f.m$i.m add command -label "None" \
					-command "routine::figure:mapping:selectDancer $w $i -1"

		  grid $f.d$i $f.t$i $f.m$i -sticky news -padx 5 -pady 2
		  incr i
	  }
	  grid columnconfig $f {0 1 2} -weight 1
	  set data(t:nbmap) $i
	  figure:mapping:initDancers $w


	# color of the figure to insert
	label $top.color_l -text "Color"
	image create photo __editmap__ -height 28 -width 96
	figure:mapping:searchColor $w
	__editmap__ put $data(t:color) -to 3 3 93 24
	menubutton $top.color -indicatoron 1 -menu $top.color.m -image __editmap__ \
			  -relief raised -anchor w -direction below -bd 1
	  figure:mapping:createColorMenu $w $top.color.m "routine::figure:mapping:chooseColor $w"

	# check box for included notes
	label $top.notes_l -text "Notes" -justify left
	set data(t:notes) 1
	checkbutton $top.notes -text "include notes from figure" -bd 1 \
			-variable routine::${w}(t:notes) -relief flat

	# check box for include as keyframes
	label $top.keys_l -text "Keyframes" -justify left
	set data(t:keys) 0
	checkbutton $top.keys -text "include figure as keyframes" -bd 1 \
			-variable routine::${w}(t:keys) -relief flat

	# check box for insertion / apply
	label $top.apply_l -text "Insertion" -justify left
	set f [frame $top.apply]
	  radiobutton $f.apply -text "add" -value 1 -bd 1 \
			  -variable routine::${w}(t:apply) -relief flat
	  radiobutton $f.insert -text "insert" -value 0 -bd 1 \
			  -variable routine::${w}(t:apply) -relief flat
	  pack $f.apply -side left
	  pack $f.insert -side left -padx 5
	if {$apply == "insertonly"} {
		set data(t:apply) 0
		$f.apply configure -state disabled
		$f.insert configure -state disabled
	} else {
		if {$apply == "true"} {
			set data(t:apply) 1
		} else {
			set data(t:apply) 0
		}
	}

	# the layout
	grid $top.map_l		$top.map		-sticky nw -padx 5 -pady 5
	grid $top.color_l	$top.color		-sticky nws -padx 5 -pady 5
	grid $top.notes_l	$top.notes		-sticky nws -padx 5 -pady 5
	grid $top.keys_l	$top.keys		-sticky nws -padx 5 -pady 5
	grid $top.apply_l	$top.apply		-sticky nws -padx 5 -pady 5
	grid rowconfig    $top {0 1 2 3} -weight 0
	grid columnconfig $top {0} -weight 0
	grid columnconfig $top {1} -weight 1
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:mapping:createColorMenu {w menu callback} {

	menu $menu -activeborderwidth 2 -bd 1 -font menubutton -tearoff 0
	foreach color {#FFFFC28F6666 #FFFFD1EB8CCC #FFFFE147B332 #FFFFFAE08000
				   \#FFFFF8514000 #D999FFFF4000 #A3D6FFFF8CCC #8CCCFFFFBAE1
				   \#C28FFFFFB332 #B332FFFFD1EB #8CCCFFFFFFFF #8CCCBAE1FFFF
				   \#6666A3D6FFFF #4CCD7EF9FFFF #333353F7FFFF #A3D68CCCFFFF
				   \#E8F58CCCFFFF #FFFF8CCCD1EB #FFFFB332E147 #FFFFB332B332
				   \#FFFF8CCC8CCC #FFFF66666666} {
		$menu add command -label "                   " \
				-background $color -activebackground $color \
				-command "$callback $color"
	}
	$menu add separator
	$menu add command -label "Choose ..." -command "$callback {}"
}

proc routine::figure:mapping:searchColor {w} {
variable $w
upvar 0 $w data

	set data(t:color) [lindex { #FFFFC28F6666 #FFFFD1EB8CCC #FFFFE147B332 #FFFFFAE08000
							   \#FFFFF8514000 #D999FFFF4000 #A3D6FFFF8CCC #8CCCFFFFBAE1
							   \#C28FFFFFB332 #B332FFFFD1EB #8CCCFFFFFFFF #8CCCBAE1FFFF
							   \#6666A3D6FFFF #4CCD7EF9FFFF #333353F7FFFF #A3D68CCCFFFF
							   \#E8F58CCCFFFF #FFFF8CCCD1EB #FFFFB332E147 #FFFFB332B332
							   \#FFFF8CCC8CCC #FFFF66666666} $data(t:colorCounter)]
	incr data(t:colorCounter)
	if {$data(t:colorCounter) > 21} {
		set data(t:colorCounter) 0
	}
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:mapping:initDancers {w} {
variable $w
upvar 0 $w data


	set max [$data(v:routine) get dancers]
	for {set i 0} {$i<$data(t:nbmap)} {incr i} {
		if {$i < $max} {
			$data(w:map).m$i configure -text [$data(v:routine) get dancername $i]
			set data(t:d$i) $i
		} else {
			$data(w:map).m$i configure -text "None"
			set data(t:d$i) -1
		}
	}
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:mapping:selectDancer {w idx dancer} {
variable $w
upvar 0 $w data

	if {$dancer == -1} {
		$data(w:map).m$idx configure -text "None"
		set data(t:d$idx) -1
	} else {
		$data(w:map).m$idx configure -text [$data(v:routine) get dancername $dancer]
		# swap the two dancers
		for {set i 0} {$i<$data(t:nbmap)} {incr i} {
			if {$i != $idx && $data(t:d$i) == $dancer} {
				if {$data(t:d$idx) == -1} {
					$data(w:map).m$i configure -text "None"
				} else {
					$data(w:map).m$i configure \
							-text [$data(v:routine) get dancername $data(t:d$idx)]
				}
				set data(t:d$i) $data(t:d$idx)
				set data(t:d$idx) $dancer
				break
			}
		}
		if {$i == $data(t:nbmap)} {
			# what not found : means a switch from none to an unused dancer
			set data(t:d$idx) $dancer
		}
	}
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:mapping:chooseColor {w color} {
variable $w
upvar 0 $w data


	if {$color == {}} {
		set color [tk_chooseColor]
		if {$color == ""} {
			return
		}
	}
	set data(t:color) $color
	__editmap__ put $color -to 3 3 93 24
}

#=================================================================================================

proc routine::figure:conflicts {w names apply} {
variable $w
upvar 0 $w data

	set top [$data(w:t:notebook) subwidget conflict]

	# a simple list for the dancer in figure
	tixScrolledHList $top.l -option {hlist.Width 10} -highlightcolor lightgray
	set data(w:t:dancer) [$top.l subwidget hlist]
	bind $data(w:t:dancer) <1> "routine::figure:conflicts:dancer $w \
										\[$data(w:t:dancer) nearest %y\]"
	set data(t:style) [tixDisplayStyle text -refwindow $top.l -fg gray -bg gray92]

	# a check hlist
	set data(w:t:list) [tixAutoCheckList $top.c -height 125 -highlightthickness 1 \
							-highlightcolor lightgray]

	$top.c subwidget hlist add pose -text "Pose"
	foreach {i n} {
		1 "Body"
			1.0 "Head" 1.1 "Torso" 1.2 "Pelvis"
		2 "Arms"
			2.1 "Left arm"
				2.1.1 "Shoulder" 2.1.2 "Elbow" 2.1.3 "Wrist"
			2.2 "Right arm"
				2.2.1 "Shoulder" 2.2.2 "Elbow" 2.2.3 "Wrist"
		3 "Legs"
			3.1 "Left leg"
				3.1.1 "Hip" 3.1.2 "Knee" 3.1.3 "Ankle" 3.1.4 "Foot"
			3.2 "Right leg"
				3.2.1 "Hip" 3.2.2 "Knee" 3.2.3 "Ankle" 3.2.4 "Foot"} {

		$top.c subwidget hlist add pose.$i -text $n
		$top.c setstatus pose.$i off
	}

	$top.c subwidget hlist add cog -text "C.o.g."
	foreach {i n} {
		1 "Position"
			1.1 "Floor" 1.2 "Altitude"
		2 "Angles"
			2.1 "Orientation" 2.2 "Roll" 2.3 "Bend"} {

		$top.c subwidget hlist add cog.$i -text $n
		$top.c setstatus cog.$i off
	}

	$top.c configure -callback "routine::figure:conflicts:select $w"
	$top.c autosetmode
	foreach i {pose.1 pose.2.1 pose.2.2 pose.3.1 pose.3.2 cog.1 cog.2} {
		$top.c close $i
	}

	pack $top.l $top.c -side left -expand true -fill both -padx 3 -pady 3
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:conflicts:setup {w names} {
variable $w
upvar 0 $w data
variable common


	# build list of conflicts and reject list
	set data(t:map) {}
	for {set i 0} {$i<$data(t:nbmap)} {incr i} {
		lappend data(t:map) $data(t:d$i)
	}
	set data(t:conflicts) [$data(v:routine) checkinsertion $data(t:figure) \
									$data(t:apply) $data(t:dropTime) $data(t:map)]
	set data(t:rejects) $data(t:conflicts)

	# build list of dancer
	$data(w:t:dancer) delete all
	set i 0
	foreach m $data(t:map) {
		if {$m == -1} {
			$data(w:t:dancer) add $i -text "[lindex $names $i] / None" -state disabled \
					-itemtype text -style $data(t:style)
		} else {
			set name [$data(v:routine) get dancername $data(t:d$i)]
			$data(w:t:dancer) add $i -text "[lindex $names $i] / $name" -itemtype text
		}
		incr i
	}

	# reset checklist
	set data(t:reject) {}
	$data(w:t:list) setstatus pose off
	$data(w:t:list) setstatus cog off

	# some init
	set data(t:dancer) -1
	set data(t:setup) 1
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:conflicts:dancer {w dancer} {
variable $w
upvar 0 $w data
variable commonReverse


	if {[$data(w:t:dancer) entrycget $dancer -state] == "disabled"} {
		return
	}

	# store current reject
	if {$data(t:dancer) != -1} {
		set data(t:rejects) [lreplace $data(t:rejects) $data(t:dancer) \
									$data(t:dancer) $data(t:reject)]
	}

	# reset checklist
	$data(w:t:list) setstatus pose off
	$data(w:t:list) setstatus cog off

	# change dancer & update checklist
	set data(t:dancer) $dancer
	set data(t:reject) [lindex $data(t:rejects) $dancer]

	foreach c $data(t:reject) {
		$data(w:t:list) setstatus $commonReverse($c) on
	}
}


#-------------------------------------------------------------------------------------------------
#	source routine_insert.tcl ; routine::figure:handleConflicts .toto

proc routine::figure:conflicts:select {w entry mode} {
variable $w
upvar 0 $w data
variable common


	if {$mode == "on" && [lsearch $data(t:reject) $common($entry)] == -1
			&& $common($entry) != ""} {
		lappend data(t:reject) $common($entry)
	} elseif {$mode == "off" && [set i [lsearch $data(t:reject) $common($entry)]] != -1} {
		set data(t:reject) [lreplace $data(t:reject) $i $i]
	}
}

#-------------------------------------------------------------------------------------------------

proc routine::figure:conflicts:check {w} {
variable $w
upvar 0 $w data

	# save current state
	if {$data(t:dancer) != -1} {
		set data(t:rejects) [lreplace $data(t:rejects) $data(t:dancer) \
									$data(t:dancer) $data(t:reject)]
	}

	# do the check = reject list against conflict list
	set i 0
	foreach c $data(t:conflicts) r $data(t:rejects) {
		foreach j $c {
			if {[lsearch $r $j] == -1} {
				set data(t:error) "Error in merging.\nConflict for '[$data(w:t:dancer) entrycget $i -text]' in the track '$j'"
				return 0
			}
		}
		incr i
	}
	return 1
}

#=================================================================================================

# set routine::.routine(t:dropTime) 2000; 
# source routine_insert.tcl; routine::figure:insert .routine Waltz/waltz


proc routine::figure:insert {w figure} {
variable $w
upvar 0 $w data


	# get info from routine
	set r [::routine]
	$r load $figure

	# if at the end of routine, then add
	if {$data(t:dropTime) >= [$data(v:routine) get beats]} {
		set apply insertonly
	} else {
		set apply true
	}
	# dialog to ask what to do with figure
	if {[figure:dialog $w $r $apply] != "OK"} {
		rename $r {}
		return
	}

	set result [$data(v:routine) insert $r $figure \
			$data(t:color) $data(t:notes) $data(t:keys) \
			$data(t:apply) $data(t:dropTime) $data(t:map) $data(t:rejects)]
#puts "INSERTION at $data(t:dropTime) with reject $data(t:rejects) -- len [$r get beats] -- result = $result"

	# update canvas
	canvas:add:figure $w $r $result $data(t:apply)

	# if add a figure in insert mode & apply to all dancer, add a main comment
	if {!$data(t:apply) && [$r get dancers] == [$data(v:routine) get dancers] \
			&& [lsearch -exact $data(t:map) -1] == -1
			&& [$data(v:routine) note exists $data(t:dropTime) -1] == -1 } {
		# create the note
		set id [$data(v:routine) note add $data(t:dropTime) \
				[expr $data(t:dropTime)+[$r get beats]] -1 [$r get name]]
		# create the graphical note
		set data(t:ids) {}
		set c $data(w:canvas)
		set sx [expr $data(t:dropTime)*$data(v:zoom)]
		set ex [expr ($data(t:dropTime)+[$r get beats])*$data(v:zoom)]
		lappend data(t:ids) [$c create image $sx 8 -image pointblue -tags "d-1 d-1.notes"]
		lappend data(t:ids) [$c create line $sx 8 $ex 8 $ex 3 $ex 14 -tags "d-1 d-1.notes"]
		$c raise [lindex $data(t:ids) 1] grid
		$c raise [lindex $data(t:ids) 0]
		note:bindings $w $id $data(t:ids)
	}

	# update viewtracks & movies end
	set time [$data(v:routine) get beats]
	foreach track $viewTrack::list {
		viewTrack::setMaxTime $track $time
	}		

	# clear old routine
	rename $r {}

	# resync routine
	sync $w [$data(v:routine) get time]
}
