CLASS 		ViewMovie
EXTENDS		View3D

CODE_SET	Togl_PostRedisplay(togl);


#-------------------------------------------------------------------------------------------------
# name			type		var associated			set code (%!=entry idx, %$ = var name)

time			int			askedTime				currentTime = askedTime;\
													if (mode == VIEW) Viewpoint(interp, 0, NULL);
mode			user		-
movie			user		-
showheight		bool		showHeight
showhandle		bool		showHandle
showline		bool		showLine
showpaths		bool		showPaths
colorEye		color		colorEye
colorCenter		color		colorCenter


#------------------------------------------------------------------------------------------------
#	 name		vars in list


#================================================================================================

USER_SET mode		{__str = Tcl_GetStringFromObj(objv[3], NULL); \
					if (strcmp(__str, "edit") == 0) { \
						mode = EDIT; \
					} else if (strcmp(__str, "view") == 0) { \
						mode = VIEW; \
					} else if (strcmp(__str, "play") == 0) { \
						mode = PLAY; \
					} else { \
						Tcl_AppendResult(interp,"bad mode", (char *) NULL); \
						return TCL_ERROR; \
					}}

USER_GET mode		__res = Tcl_NewStringObj((char *) (mode == EDIT ? "edit" : \
													   mode == VIEW ? "view" : "play"), -1);

#------------------------------------------------------------------------------------------------

USER_GET movie		{Tcl_SetResult(interp,"can't get movie", TCL_STATIC); \
					return TCL_ERROR;}

USER_SET movie		{class Routine *routine; ListIterator<Movie> m; struct Tcl_CmdInfo info; \
					if (objc!=5) { \
						Tcl_WrongNumArgs(interp, 3, objv, "routine name"); \
						return TCL_ERROR; \
					} \
					__str = Tcl_GetStringFromObj(objv[3], NULL); \
					if (Tcl_GetCommandInfo(interp, __str, &info) == 0 || *__str != 'r') { \
						Tcl_AppendResult(interp,"no routine named \"",__str,"\"",(char *) NULL); \
						return TCL_ERROR; \
					} \
					routine = (class Routine *) info.objClientData; \
					__str = Tcl_GetStringFromObj(objv[4], NULL); \
					for(m.reset(routine->movies); m; ++m) { \
						if (strcmp(m()->name(), __str) == 0) { \
							eye = m()->eye(); \
							center = m()->center(); \
							currentEye.reset(eye); \
							currentCenter.reset(center); \
							break; \
						} \
					} \
					if (!m) { \
						if (*__str == '\0') { \
							eye = center = 0; \
							currentEye.reset(eye); \
							currentCenter.reset(center); \
						} else { \
							Tcl_AppendResult(interp,"no movie named \"",__str,"\" in \"", \
									Tcl_GetStringFromObj(objv[3], NULL), "\"", (char *) NULL); \
							return TCL_ERROR; \
						} \
					}\
					currentTime = askedTime; \
					Togl_PostRedisplay(togl); \
					}
